<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  data() {
    return {
      modalContent: {
        heading_en: 'Visiting GitLab from Mainland China, Macau, or Hong Kong?',
        paragraph_en:
          'We advise you to visit the JiHu website. JiHu is an independent company with the exclusive right to provide a localized GitLab offering that is tailored to assist individuals based in these geographies.',
        heading_cn:
          '尊敬的用户，我们注意到您正在从中国大陆、中国香港地区或中国澳门地区访问 GitLab。',
        paragraph_cn:
          '我们建议您访问极狐页面。极狐是一家独立经营运作的公司，具有上述地区内GitLab产品的永久唯一独家授权，并向用户提供本地化的GitLab产品。',
        primaryCta: {
          text: 'Take me to JiHu (去极狐GitLab)',
          url: 'https://gitlab.cn/',
        },
        secondaryCta: { text: 'Continue to GitLab.com' },
      },
      modalContentInstall: {
        heading_en: 'Visiting GitLab from Mainland China, Macau, or Hong Kong?',
        paragraph_en:
          'We advise you to install offerings from the JiHu website. JiHu is an independent company with the exclusive right to provide a localized GitLab offering that is tailored to assist individuals based in these geographies.',
        heading_cn:
          '尊敬的用户，我们注意到您正在从中国大陆、中国香港地区或中国澳门地区访问 GitLab。',
        paragraph_cn:
          '我们建议您从极狐页面下载产品。极狐是一家独立经营运作的公司，具有上述地区内GitLab产品的永久唯一独家授权，并向用户提供本地化的GitLab产品。',
        primaryCta: {
          text: 'Install JiHu (下载极狐GitLab)',
          url: 'https://gitlab.cn/install',
        },
        secondaryCta: { text: 'Continue to GitLab.com' },
      },
    };
  },
  computed: {
    currentModalContent() {
      const isInstallPage = this.$route.path.includes('install');
      return isInstallPage ? this.modalContentInstall : this.modalContent;
    },
  },
  mounted() {
    document.querySelector('body').classList.add('noScroll');
  },
  destroyed() {
    document.querySelector('body').classList.remove('noScroll');
  },
  methods: {
    emitClose() {
      this.$emit('close');
    },
  },
});
</script>

<template>
  <div>
    <div v-if="currentModalContent">
      <nav class="minimal-nav">
        <img
          class="desktop"
          src="/nuxt-images/free-trial/free-trial-nav-logo.svg"
          width="160px"
        />
        <img
          class="mobile"
          src="/nuxt-images/free-trial/free-trial-nav-logo-mobile.svg"
          width="25px"
        />
      </nav>
      <div class="backdrop">
        <div role="dialog" aria-modal="true" class="modal">
          <div class="modal__content slp-mx-24">
            <SlpIcon
              name="pin-user"
              variant="marketing"
              size="lg"
              class="slp-mb-24"
            />
            <SlpTypography tag="h2" variant="heading5-bold">
              {{ currentModalContent.heading_en }}
            </SlpTypography>
            <SlpTypography tag="p" variant="body2" class="paragraph">
              {{ currentModalContent.paragraph_en }}
            </SlpTypography>
            <SlpTypography tag="h2" variant="heading5-bold">
              {{ currentModalContent.heading_cn }}
            </SlpTypography>
            <SlpTypography tag="p" variant="body2" class="paragraph">
              {{ currentModalContent.paragraph_cn }}
            </SlpTypography>
            <SlpButton
              variant="primary"
              data-ga-location="jihu-modal"
              :data-ga-name="currentModalContent.primaryCta.text"
              :href="currentModalContent.primaryCta.url"
            >
              {{ currentModalContent.primaryCta.text }}
            </SlpButton>
            <SlpButton
              aria-label="Close dialog"
              variant="tertiary"
              data-ga-location="jihu-modal"
              :data-ga-name="currentModalContent.secondaryCta.text"
              type="button"
              @click.native="emitClose"
            >
              {{ currentModalContent.secondaryCta.text }}
            </SlpButton>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
nav {
  display: flex;
  justify-content: space-between;
  padding: 13px $spacing-32;
  left: 0;
  position: sticky;
  right: 0;
  top: 0;
  z-index: 1028;
  position: absolute;
  background: $color-surface-50;
  backdrop-filter: blur(16px);
  -webkit-backdrop-filter: blur(16px);

  .mobile {
    display: none;
  }

  @media (max-width: $breakpoint-md) {
    flex-wrap: wrap;
    flex-direction: column-reverse;
    justify-content: center;
    padding: 0;

    .desktop {
      display: none;
    }

    .mobile {
      display: block;
      margin: 12px auto;
    }
  }
}
.backdrop {
  position: absolute;
  top: 48px;
  bottom: 0;
  left: 0;
  right: 0;
  background-color: $color-surface-100;
  display: flex;
  justify-content: center;
  align-items: center;
  z-index: 1026;
  overflow-y: scroll;
}

.paragraph {
  margin-top: 10px;
  margin-bottom: $spacing-24;
}

.modal {
  display: flex;
  flex-direction: column;
  position: relative;
  max-width: 1110px;

  .slp-btn {
    margin-right: $spacing-16;
  }

  .slp-icon {
    margin-top: 90px;
  }

  @media (max-width: $breakpoint-md) {
    .slp-btn {
      width: 100%;
      margin: 0;
      justify-content: center;
    }
  }
}
</style>
